- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# iosxr_banner – Manage multiline banners on Cisco IOS XR devices

New in version 2.4.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- This module will configure both exec and motd banners on remote device running Cisco IOS XR. It allows playbooks to add or remove banner text from the running configuration.

## Requirements

The below requirements are needed on the host that executes this module.

- ncclient >= 0.5.3 when using netconf

- lxml >= 4.1.1 when using netconf

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
banner - / required | Choices: login motd | Specifies the type of banner to configure on remote device.
provider dictionary |  | Deprecated Starting with Ansible 2.5 we recommend using `connection: network_cli`. For more information please see the Network Guide. A dict object containing connection details.
| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.
state - | Choices: present ← absent | Existential state of the configuration on the device.
text - |  | Banner text to be configured. Accepts multiline string, without empty lines. Requires state=present.

## Notes

Note

- Tested against IOS XRv 6.1.3.

- This module works with connection `network_cli` and `netconf`. See the IOS-XR Platform Options.

- For more information on using Ansible to manage network devices see the Ansible Network Guide

- For more information on using Ansible to manage Cisco devices see the Cisco integration page.

## Examples

    - name: configure the login banner
      iosxr_banner:
        banner: login
        text: |
          this is my login banner
          that contains a multiline
          string
        state: present
    - name: remove the motd banner
      iosxr_banner:
        banner: motd
        state: absent
    - name: Configure banner from file
      iosxr_banner:
        banner:  motd
        text: "{{ lookup('file', './config_partial/raw_banner.cfg') }}"
        state: present

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
commands list | always (empty list when no commands to send) | The list of configuration mode commands sent to device with transport `cli` Sample: ['banner login', 'this is my login banner', 'that contains a multiline', 'string']
xml list added in 2.5 | always (empty list when no xml rpc to send) | NetConf rpc xml sent to device with transport `netconf` Sample: ['<config xmlns:xc="urn:ietf:params:xml:ns:netconf:base:1.0"> <banners xmlns="http://cisco.com/ns/yang/Cisco-IOS-XR-infra-infra-cfg"> <banner xc:operation="merge"> <banner-name>motd</banner-name> <banner-text>Ansible banner example</banner-text> </banner> </banners> </config>']

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Trishna Guha (@trishnaguha)

- Kedar Kekan (@kedarX)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.